#include <bits/stdc++.h>

#define DIGS 10

using namespace std;

ifstream fin("date.in");

int N;
string x;
int G[26];
bitset <27 * 27> matrix[1 << DIGS];
int lsb[1 << 13];
int clique_size[1 << 13];
bool is_clique[1 << 13];
int ri_conf[1 << 13];
int freq[1 << DIGS];

pair<int, int> process(string s) {
    pair <int, int> letters = make_pair(0, 0);
    int conf = 0;
    for(auto it : s) {
        if('0' <= it && it <= '9') {
            conf |= (1 << (it - '0'));
        }
        else {
            if(letters.first == 0) {
                letters.first = it - 'A' + 1;
            }
            else if(letters.first != it - 'A' + 1) {
                letters.second = it - 'A' + 1;
            }
        }
    }

    return make_pair(conf, letters.first + 27 * letters.second);
}

inline pair <int, int> decode(int val) {
    return make_pair(val % 27 - 1, val / 27 - 1);
}

int max_clique(int N, int G[]) {
    int mid = N / 2;

    memset(clique_size, 0, sizeof(clique_size));
    memset(ri_conf, 0, sizeof(ri_conf));
    memset(is_clique, false, sizeof(is_clique));

    for(int conf = 1; conf < (1 << mid); conf++) { ///partea din dreapta
        clique_size[conf] = max(clique_size[conf ^ (1 << lsb[conf])], 1 + clique_size[((conf << mid) & G[mid + lsb[conf]]) >> mid]);
    }

    is_clique[0] = true;
    int ret = 0;
    for(int conf = 1; conf < (1 << mid); conf++) {
        if(conf == (1 << lsb[conf])) {
            ri_conf[conf] = (G[lsb[conf]] >> mid);
        }
        else {
            ri_conf[conf] = ri_conf[conf ^ (1 << lsb[conf])] & (G[lsb[conf]] >> mid);
        }

        is_clique[conf] = ((conf ^ (1 << lsb[conf])) & G[lsb[conf]]) == (conf ^ (1 << lsb[conf])) && is_clique[(conf ^ (1 << lsb[conf]))];
        if(is_clique[conf]) {
            ret = max(ret, __builtin_popcount(conf) + clique_size[ri_conf[conf]]);
        }
    }

    return ret;
}

int minimum_vertex_cover(bitset <27 * 27> &b) {
    int f[26];
    for(int i = 0; i < 26; i++) {
        f[i] = 1;

    }

    int ret = 0;
    for(int i = 1; i < 27 * 27; i++) {
        if(b[i]) {
            auto e = decode(i);
            if(e.second == -1) {
                ret += f[e.first];
                f[e.first] = 0;
            }
        }
    }

    memset(G, 0, sizeof(G));

    for(int i = 1; i < 27 * 27; i++) {
        if(b[i]) {
            auto e = decode(i);
            if(e.second != -1) {
                if(f[e.first] && f[e.second]) {
                    //cout << e.first << " " << e.second << "\n";
                    G[e.first] |= 1 << e.second;
                    G[e.second] |= 1 << e.first;
                }
            }
        }
    }

    //getchar();

    for(int i = 0; i < 26; i++) {
        G[i] = (1 << 26) - 1 - G[i] - (1 << i);
    }

    return ret + 26 - max_clique(26, G);
}

// aassert solution 100 points
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> N;
    assert (1 <= N && N <= 250000);
    int totalLength = 0;
    int cnt = 0;
    for(int i = 1; i <= N; i++) {
        cin >> x;
       	assert(x.size() != 0);
        totalLength += x.size();
        for (int poz = 0; poz < x.size(); ++poz)
        	assert(('0' <= x[poz] && x[poz] <= '9') || ('A' <= x[poz] && x[poz] <= 'Z'));
        auto p = process(x);
        matrix[p.first][p.second] = 1;
        if(p.second == 0) {
            cnt++;
            freq[p.first]++;
        }
    }
    assert(totalLength <= 4000000);
    for(int bit = 0; bit < DIGS; bit++) {
        for(int conf = 0; conf < (1 << 10); conf++) {
            if(conf & (1 << bit)) {
                matrix[conf] |= matrix[conf ^ (1 << bit)];
                freq[conf] += freq[conf ^ (1 << bit)];
            }
        }
    }

    for(int i = 1; i < (1 << 13); i++) {
        if(i % 2 == 1) {
            lsb[i] = 0;
        }
        else {
            lsb[i] = 1 + lsb[i / 2];
        }
    }

    int ans = 36;
    for(int conf = 0; conf < (1 << DIGS); conf++) {
        int comp = (1 << DIGS) - 1 - conf;
        if(freq[comp] != 0) {
            continue;
        }
        ans = min(ans, __builtin_popcount(conf) + minimum_vertex_cover(matrix[comp]));
    }

    cout << ans << "\n";
    return 0;
}
