#include <bits/stdc++.h>

#define N_MAX 200000

using namespace std;

struct PersistenTrie {
    struct TrieNode {
        int freq;
        TrieNode *nxt[2];

        TrieNode() {
            freq = 0;
            nxt[0] = nxt[1] = this;
        }
        TrieNode(TrieNode *nil) {
            freq = 0;
            nxt[0] = nxt[1] = nil;
        }
    };

    TrieNode *root[N_MAX + 5];
    TrieNode *nil;
    PersistenTrie() {
        nil = new TrieNode();
        root[0] = new TrieNode(nil);
    }

    void insert(int t, int value) {
        root[t] = new TrieNode(nil);
        TrieNode *curr = root[t], *last = root[t - 1];
        for(int i = 29; i >= 0; i--) {
            int t = 0;
            if(value & (1 << i)) {
                t = 1;
            }
            curr->nxt[t] = new TrieNode(nil);
            curr->nxt[t]->freq = last->nxt[t]->freq + 1;
            curr->nxt[1 - t] = last->nxt[1 - t];
            curr = curr->nxt[t];
            last = last->nxt[t];
        }
    }

    int query(int le, int ri, int value) {
        TrieNode *node_le = root[le - 1], *node_ri = root[ri];
        int ret = 0;
        for(int i = 29; i >= 0; i--) {
            int t = 0;
            if(value & (1 << i)) {
                t = 1;
            }
            if(node_ri->nxt[1 - t]->freq - node_le->nxt[1 - t]->freq > 0) {
                node_ri = node_ri->nxt[1 - t];
                node_le = node_le->nxt[1 - t];
                ret += (1 - t) << i;
            }
            else {
                node_ri = node_ri->nxt[t];
                node_le = node_le->nxt[t];
                ret += t << i;
            }
        }
        return ret;
    }
};

PersistenTrie T;
int N, Q;
int A[N_MAX + 5];

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> N >> Q;
    for(int i = 1; i <= N; i++) {
        cin >> A[i];
        T.insert(i, A[i]);
        A[i] ^= A[i - 1];
    }

    while(Q--) {
        int le, ri;
        cin >> le >> ri;
        cout << (A[ri] ^ A[le - 1] ^ T.query(le, ri, A[ri] ^ A[le - 1])) << "\n";
    }
    return 0;
}
