#include <bits/stdc++.h>

#define S_MAX 200000
#define N_MAX 200000

using namespace std;

ifstream fin("date.in");

int N;
string W[N_MAX + 5];
string S;

int suf[18][S_MAX + 5];
int start_index[N_MAX + 5];
vector<int> index_W;
vector< pair <int, int> > aux;
int ans[N_MAX + 5];
int le[N_MAX + 5], ri[N_MAX + 5];

int LCP(int x, int y) {
    int curr_string_x = index_W[x];
    int start_x = start_index[curr_string_x];
    int curr_string_y = index_W[y];
    int start_y = start_index[curr_string_y];

    int ret = 0;
    for(int bit = 17; bit >= 0; bit--) {
        if(x + (1 << bit) > start_x + W[curr_string_x].size()) {
            continue;
        }
        if(y + (1 << bit) > start_y + W[curr_string_y].size()) {
            continue;
        }

        if(suf[bit][x] == suf[bit][y]) {
            ret += (1 << bit);
            x += (1 << bit);
            y += (1 << bit);
        }
    }
    return ret;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> N;
    for(int i = 1; i <= N; i++) {
        cin >> W[i];
        start_index[i] = S.size();
        S += W[i];
        fill_n(back_inserter(index_W), W[i].size(), i);
    }

    for(int i = 0; i < S.size(); i++) {
        suf[0][i] = S[i];
    }

    for(int bit = 1; bit < 18; bit++) {
        aux.resize(S.size());
        for(int i = 0; i < S.size(); i++) {
            int curr_string = index_W[i];
            int start = start_index[curr_string];
            aux[i] = make_pair(suf[bit - 1][i], (i + (1 << (bit - 1)) < start + W[curr_string].size() ? suf[bit - 1][i + (1 << (bit - 1))] : -1));
        }

        sort(aux.begin(), aux.end());
        aux.resize(unique(aux.begin(), aux.end()) - aux.begin());

        for(int i = 0; i < S.size(); i++) {
            int curr_string = index_W[i];
            int start = start_index[curr_string];
            suf[bit][i] = lower_bound(aux.begin(), aux.end(), make_pair(suf[bit - 1][i], (i + (1 << (bit - 1)) < start + W[curr_string].size() ? suf[bit - 1][i + (1 << (bit - 1))] : -1))) - aux.begin();
        }
    }

    aux.resize(S.size());

    for(int i = 0; i < S.size(); i++) {
        aux[i] = make_pair(i, index_W[i]);
    }
    sort(aux.begin(), aux.end(), [](pair<int, int> a, pair<int, int> b) {
        return suf[17][a.first] < suf[17][b.first];
    });

    for(int i = 1; i <= N; i++) {
        ans[i] = S.size() + 1;
    }

    le[0] = -1;
    for(int i = 1; i < S.size(); i++) {
        le[i] = le[i - 1];
        if(aux[i].second != aux[i - 1].second) {
            le[i] = i - 1;
        }

    }
    ri[S.size() - 1] = -1;
    for(int i = S.size() - 2; i >= 0; i--) {
        ri[i] = ri[i + 1];
        if(aux[i].second != aux[i + 1].second) {
            ri[i] = i + 1;
        }
    }

    for(int i = 0; i < S.size(); i++) {
        int l = -1, r = -1;

        if(le[i] != -1) {
            l = LCP(aux[i].first, aux[le[i]].first);
        }
        if(ri[i] != -1) {
            r = LCP(aux[i].first, aux[ri[i]].first);
        }

        if(aux[i].first + max(l, r) != start_index[aux[i].second] + W[aux[i].second].size()) {
            ans[aux[i].second] = min(ans[aux[i].second], max(l, r) + 1);
        }
    }

    for(int i = 1; i <= N; i++) {
        if(ans[i] > W[i].size()) {
            cout << "-1\n";
        }
        else {
            cout << ans[i] << "\n";
        }
    }
    return 0;
}
