// stud. Vlad-Mihai Bogdan
// Universitatea din Bucuresti
#include <bits/stdc++.h>
using namespace std;

const int P = 29;
const int M = (int)1e9 + 9;

string S;
unordered_map<int, unordered_set<int>> hashes;
vector<int> offset(1, 1), prefixHash(1, 0);

int getHash(const string &S) {
    int h = 0;
    for (const char &c : S) {
        h = ((long long)h * P + (int)c) % M;
    }
    return h;
}

bool verifySufix() {
    for (const auto &W : hashes) {
        int len = W.first;
        if (len <= (int)S.size()) {
            int suffixHash = (long long)prefixHash[(int)S.size() - len] * offset[len] % M;
            suffixHash = (prefixHash.back() - suffixHash + M) % M;
            if (W.second.find(suffixHash) != W.second.end()) {
                S.resize((int)S.size() - len);
                prefixHash.resize((int)prefixHash.size() - len);
                offset.resize((int)offset.size() - len);
                return true;
            }
        }
    }
    return false;
}

int main() {
    int Q; cin >> Q;
    for (int i = 0; i < Q; i++) {
        int op; cin >> op;
        if (op == 0) {
            char c; cin >> c;
            S += c;
            offset.push_back((long long)offset.back() * P % M);
            prefixHash.push_back(((long long)prefixHash.back() * P + (int)c) % M);
        } else if (op == 1) {
            prefixHash.pop_back();
            offset.pop_back();
            S.pop_back();
        } else if (op == 2) {
            string W; cin >> W;
            int stringHash = getHash(W);
            hashes[(int)W.size()].insert(stringHash);
        } else if (op == 3) {
            string W; cin >> W;
            int stringHash = getHash(W);
            hashes[(int)W.size()].erase(stringHash);
        }

        while (verifySufix());
        cout << (S.empty() ? '?' : (char)S.back());
    }
    return 0;
}
